#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Copyright: Damien Elmes <anki@ichi2.net>
# License: GNU GPL, version 2 or later; http://www.gnu.org/copyleft/gpl.html

try:
    __import__('pkg_resources').declare_namespace(__name__)
except ImportError:
    pass

version = "0.4.2"

from anki.sched import Scheduler as _sched
from anki.deck import DeckStorage as _ds
import sys, os

class Controller(object):
    "A factory for getting elements based on the current policy."

    scheduler = _sched
    storageClass = _ds
    factModel = 'Other'
    backupDir = unicode(os.path.expanduser("~/.anki/backups"),
                        sys.getfilesystemencoding())

    def Deck():
        from anki.deck import Deck
        from anki.stdmodels import byName
        return Deck(Controller.scheduler(),
                    byName(Controller.factModel))
    Deck = staticmethod(Deck)

    def DeckStorage():
        return Controller.storageClass()
    DeckStorage = staticmethod(DeckStorage)
