# coding: utf-8

import nose, os, tempfile
import anki
from anki.errors import *
from anki.facts import *
from anki.models import *
from anki.importing import *
from anki.exporting import *
from anki.sync import *
from anki import stdmodels

deck = None
ds = None
testDir = os.path.dirname(__file__)

def setup1():
    global deck, ds
    deck = anki.Controller.Deck()
    ds = anki.Controller.DeckStorage()
    file = unicode(os.path.join(testDir, "importing/test-v8-jp.fc"))
    model = stdmodels.byName("Japanese")
    AnkiV2Importer(file, model).importInto(deck)

def assertException(exception, func):
    found = False
    try:
        func()
    except exception:
        found = True
    assert found

##########################################################################

@nose.with_setup(setup1)
def test_export_anki():
    oldTime = deck.modified
    e = AnkiExporter(deck)
    e.exportInto(unicode(tempfile.mkstemp()[1]))
    assert deck.modified == oldTime
    # check we haven't clobbered any links
    deck2 = anki.Controller.Deck()
    client = SyncClient(deck)
    server = SyncServer(deck2)
    client.setServer(server)
    client.sync()

@nose.with_setup(setup1)
def test_export_textcard():
    e = TextCardExporter(deck)
    e.exportInto(unicode(tempfile.mkstemp()[1]))

@nose.with_setup(setup1)
def test_export_textfact():
    e = TextFactExporter(deck)
    e.exportInto(unicode(tempfile.mkstemp()[1]))
